﻿Public Class TabControlEx
    Inherits TabControl

    Sub New()
        DisableNavigationKeys = True
    End Sub

#Region "Hide Tab's At Runtime"

    Private Const TCM_ADJUSTRECT As Integer = &H1328

    Protected Overrides Sub WndProc(ByRef m As Message)
        If Not DesignMode AndAlso m.Msg = TCM_ADJUSTRECT Then
            m.Result = CType(1, IntPtr)
            Return
        End If
        MyBase.WndProc(m)
    End Sub

#End Region

#Region "Disable Control Navigation Logig"

    Private _DisableNavigationKeys As Boolean
    Public Property DisableNavigationKeys() As Boolean
        Get
            Return _DisableNavigationKeys
        End Get
        Set(value As Boolean)
            _DisableNavigationKeys = value
            Select Case _DisableNavigationKeys
                Case True
                    RemoveHandler KeyDown, AddressOf Me_KeyDown
                    AddHandler KeyDown, AddressOf Me_KeyDown
                Case False
                    RemoveHandler KeyDown, AddressOf Me_KeyDown
            End Select
        End Set
    End Property

    Private Sub Me_KeyDown(sender As Object, e As KeyEventArgs)
        e.SuppressKeyPress =
            e.KeyCode = Keys.Left OrElse
            e.KeyCode = Keys.Right
    End Sub

#End Region

#Region "Custom Navigation"

    Public Sub SelectNextTabPage()
        Dim selectedTabIndex As Integer = TabPages.IndexOf(SelectedTab)
        If selectedTabIndex = TabPages.Count - 1 Then
            selectedTabIndex = 0
        Else
            selectedTabIndex = selectedTabIndex + 1
        End If
        SelectedTab = TabPages(selectedTabIndex)
    End Sub

    Public Sub SelectBeforeTabPage()
        Dim selectedTabIndex As Integer = TabPages.IndexOf(SelectedTab)
        If selectedTabIndex = 0 Then
            selectedTabIndex = TabPages.Count - 1
        Else
            selectedTabIndex = selectedTabIndex - 1
        End If
        SelectedTab = TabPages(selectedTabIndex)
    End Sub

    Public Sub SelectFirstTabPage()
        SelectedTab = TabPages(0)
    End Sub

    Public Sub SelectLastTabPage()
        SelectedTab = TabPages(TabPages.Count - 1)
    End Sub

#End Region

End Class